com.google.cloud.dataflow.sdk.transforms

## Class SimpleFunction<InputT,OutputT>

- java.lang.Object
- - com.google.cloud.dataflow.sdk.transforms.SimpleFunction<InputT,OutputT>

All Implemented Interfaces:
  SerializableFunction<InputT,OutputT>, Serializable

    public abstract class SimpleFunction<InputT,OutputT>
    extends Object
    implements SerializableFunction<InputT,OutputT>

A `SerializableFunction` which is not a functional interface. Concrete subclasses allow us to infer type information, which in turn aids `Coder` inference.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`SimpleFunction()`

### Method Summary

All Methods Instance Methods Concrete Methods
`TypeDescriptor<InputT>` `getInputTypeDescriptor()` Returns a `TypeDescriptor` capturing what is known statically about the input type of this `DoFn` instance's most-derived class.
`TypeDescriptor<OutputT>` `getOutputTypeDescriptor()` Returns a `TypeDescriptor` capturing what is known statically about the output type of this `DoFn` instance's most-derived class.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface com.google.cloud.dataflow.sdk.transforms.SerializableFunction

`apply`

### Constructor Detail

#### SimpleFunction

    public SimpleFunction()

### Method Detail

#### getInputTypeDescriptor

    public TypeDescriptor<InputT> getInputTypeDescriptor()

Returns a `TypeDescriptor` capturing what is known statically about the input type of this `DoFn` instance's most-derived class.

See `getOutputTypeDescriptor()` for more discussion.

#### getOutputTypeDescriptor

    public TypeDescriptor<OutputT> getOutputTypeDescriptor()

Returns a `TypeDescriptor` capturing what is known statically about the output type of this `DoFn` instance's most-derived class.

In the normal case of a concrete `DoFn` subclass with no generic type parameters of its own (including anonymous inner classes), this will be a complete non-generic type, which is good for choosing a default output `Coder<OutputT>` for the output `PCollection<OutputT>`.